//
// Copyright (c) 2013 Samsung Electronics Co., Ltd.
//
// Licensed under the Flora License, Version 1.1 (the License);
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://floralicense.org/license/
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an AS IS BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

#include <new>

#include "Scheduler.h"
#include "SchedulerFrame.h"
#include "SchedulerFormFactory.h"
#include "SceneRegister.h"

using namespace Tizen::App;
using namespace Tizen::Base;
using namespace Tizen::System;
using namespace Tizen::Ui::Controls;
using namespace Tizen::Ui::Scenes;


SchedulerApp::SchedulerApp(void)
{
}

SchedulerApp::~SchedulerApp(void)
{
}

UiApp*
SchedulerApp::CreateInstance(void)
{
	// Create the instance through the constructor.
	return new SchedulerApp();
}

bool
SchedulerApp::OnAppInitializing(AppRegistry& appRegistry)
{
	return true;
}

bool
SchedulerApp::OnAppInitialized(void)
{
	result r = E_SUCCESS;

	// Create a Frame
	SchedulerFrame* pSchedulerFrame = new SchedulerFrame();
	pSchedulerFrame->Construct();
	pSchedulerFrame->SetName(L"Scheduler");
	AddFrame(*pSchedulerFrame);

	// SceneManagement initializing
	SceneRegister::RegisterAllScenes();

	SceneManager* pSceneManager = SceneManager::GetInstance();
	AppAssert(pSceneManager);
	r = pSceneManager->GoForward(ForwardSceneTransition(SCENE_LIST));
	TryReturn(!IsFailed(r), false, "%s", GetErrorMessage(r));

	return true;
}

bool
SchedulerApp::OnAppWillTerminate(void)
{
	return true;
}

bool
SchedulerApp::OnAppTerminating(AppRegistry& appRegistry, bool forcedTermination)
{
	return true;
}

void
SchedulerApp::OnForeground(void)
{
}

void
SchedulerApp::OnBackground(void)
{
}

void
SchedulerApp::OnLowMemory(void)
{
}

void
SchedulerApp::OnBatteryLevelChanged(BatteryLevel batteryLevel)
{
}

void
SchedulerApp::OnScreenOn(void)
{
}

void
SchedulerApp::OnScreenOff(void)
{
}
